#include <iostream>
#include "O22SIOMM.h"
#include "O22STRCT.h"

int main() {
    const char *address = "127.0.0.1";
    // create a connection to the local EPIC, and confirm that it's successful
    O22SnapIoMemMap EPIC;
    int nResult = EPIC.OpenEnet2(address, 2001, 10000, 2, SIOMM_TCP);
    if(nResult != SIOMM_OK) {
        printf("OpenEnet2 reports result %d, exiting.\n", nResult);
        exit(0);
    }
    // wait for the connection to complete
    usleep(100000); // 0.1s

    // Use the `ReadBlockAsIntegers` function to get the integer array from a specific MMP address
//  int ReadBlockAsIntegers(uint32_t dwDestOffset, uint16_t wDataLength, int * pnData)
    uint32_t MMP = 0xF030014C; // address for the serial number
    uint16_t length = sizeof(int); // reading one integer
    int data[1]; // array to hold the single returned number.
    
    // Make the OptoMMP read command to get the integer:
    nResult = EPIC.ReadBlockAsIntegers(MMP, length, data);

    int serialNumber = data[0]; // the 0th item is the only value in the array, the serial number.
    
    // print the result:
    printf("serial number = %d\n", serialNumber);
    
    return 0;
}
